Package de.willuhn.jameica.hbci.passports.pintan.rmi

# Interface PinTanConfig

All Superinterfaces:
  `Configuration`, `de.willuhn.datasource.GenericObject`, `Remote`

All Known Implementing Classes:
  `PinTanConfigImpl`

public interface PinTanConfig extends de.willuhn.datasource.GenericObject, Configuration
Interface fuer eine einzelne PIN/TAN-Konfiguration fuer eine spezifische Bank.

## Method Summary

Modifier and Type
Method
Description
`void`
`addTanMedia(String name)`
Fuegt ein neues TAN-Medium zur Liste der bekannten hinzu.
`List<PtSecMech>`
`getAvailableSecMechs()`
Liefert die Liste der verfuegbaren TAN-Verfahren.
`List<String>`
`getAvailableTanMedias()`
Liefert die Liste der von der Bank gelieferten TAN-Medien-Bezeichnungen.
`String`
`getBezeichnung()`
Optionale Angabe einer Bezeichnung fuer die Konfig.
`String`
`getBLZ()`
Liefert die BLZ fuer die diese Config zustaendig ist.
`String`
`getCardReader()`
Liefert eine optionale Bezeichnung fuer den zu nutzenden Karteleser.
`PtSecMech`
`getCurrentSecMech()`
Liefert das aktuell ausgewaehlte TAN-Verfahren.
`String`
`getCustomerId()`
Liefert die Kundenkennung.
`String`
`getCustomProperty(String name)`
Liefert ein Custom-Property.
`String`
`getFilename()`
Dateiname der HBCI4Java-Config.
`String`
`getFilterType()`
Liefert den Filter-Typ.
`String`
`getHBCIVersion()`
Liefert die HBCI-Version.
`Konto[]`
`getKonten()`
Liefert eine optionale Liste von hart verdrahteten Konten.
`org.kapott.hbci.passport.HBCIPassport`
`getPassport()`
Liefert den Passport.
`int`
`getPort()`
Liefert den TCP-Port des Servers.
`boolean`
`getShowTan()`
Prueft, ob die TAN waehrend der Eingabe angezeigt werden soll.
`PtSecMech`
`getStoredSecMech()`
Liefert das gespeicherte TAN-Verfahren.
`String`
`getTanMedia()`
Liefert das zuletzt verwendete TAN-Medium.
`String[]`
`getTanMedias()`
Liefert die Liste der zuletzt eingegebenen TAN-Medien-Bezeichnungen.
`String`
`getURL()`
Liefert die HTTPs-URL, ueber die die Bank erreichbar ist.
`String`
`getUserId()`
Liefert die Benutzerkennung.
`Boolean`
`isChipTANUSB()`
Liefert true, wenn chipTAN USB verwendet werden soll.
`boolean`
`isConvertFlickerToQRCode()`
Liefert true, wenn statt einem Flicker-Code eine QR-Code-Abfrage erscheinen soll.
`void`
`reload()`
Forciert ein Neuladen das in der Config gespeicherten Passport.
`void`
`setAvailableSecMechs(String list)`
Speichert die Liste der verfuegbaren TAN-Verfahren.
`void`
`setAvailableTanMedias(String list)`
Speichert die Liste der von der Bank gelieferten TAN-Medien-Bezeichnungen.
`void`
`setBezeichnung(String bezeichnung)`
Speichert eine optionale Bezeichnung fuer die Konfig.
`void`
`setCardReader(String name)`
Speichert den Namen des zu verwendenden Kartenlesers.
`void`
`setChipTANUSB(Boolean b)`
Legt fest, ob chipTAN USB genutzt werden soll.
`void`
`setConvertFlickerToQRCode(boolean b)`
Legt fest, ob statt einem Flicker-Code eine QR-Code-Abfrage erscheinen soll.
`void`
`setCurrentSecMech(PtSecMech mech)`
Speichert das aktuell ausgewaehlte TAN-Verfahren.
`void`
`setCustomerId(String customer)`
Speichert die Kundenkennung.
`void`
`setCustomProperty(String name, String value)`
Speichert ein Custom-Property.
`void`
`setFilterType(String type)`
Legt den Filter-Typ fest.
`void`
`setHBCIVersion(String version)`
Speichert die zu verwendende HBCI-Version.
`void`
`setKonten(Konto[] k)`
Speichert eine optionale Liste von festzugeordneten Konten.
`void`
`setPort(int port)`
Definiert den TCP-Port.
`void`
`setShowTan(boolean show)`
Legt fest, ob die TANs bei der Eingabe angezeigt werden sollen.
`void`
`setStoredSecMech(PtSecMech mech)`
Speichert das TAN-Verfahren permanent.
`void`
`setTanMedia(String name)`
Speichert das zuletzt verwendete TAN-Medium.
`void`
`setTanMedias(String[] names)`
Speichert die Liste der zuletzt eingegebenen TAN-Medien-Bezeichnungen.
`void`
`setURL(String url)`
Speichert die HTTPs-URL, ueber die die Bank erreichbar ist.
`void`
`setUserId(String user)`
Speichert die Benutzerkennung.

### Methods inherited from interface de.willuhn.jameica.hbci.passport.Configuration

`delete, getConfigDialog, getDescription`

### Methods inherited from interface de.willuhn.datasource.GenericObject

`equals, getAttribute, getAttributeNames, getID, getPrimaryAttribute`

## Method Details

### getBLZ

String getBLZ() throws RemoteException
Liefert die BLZ fuer die diese Config zustaendig ist.

Returns:
  BLZ.
Throws:
  `RemoteException`

### getKonten

Konto[] getKonten() throws RemoteException
Liefert eine optionale Liste von hart verdrahteten Konten. Das ist sinnvoll, wenn der User mehrere Konten bei der gleichen Bank mit unterschiedlichen PIN/TAN-Konfigurationen hat. Dann wuerde bei jeder Bank-Abfrage ein Dialog zur Auswahl der Config kommen, weils Hibiscus allein anhand BLZ/Kundenkennung nicht mehr unterscheiden kann.

Returns:
  Liste der optionalen Konten oder `null` BUGZILLA 173 BUGZILLA 314
Throws:
  `RemoteException`

### setKonten

void setKonten(Konto[] k) throws RemoteException
Speichert eine optionale Liste von festzugeordneten Konten. BUGZILLA 173 BUGZILLA 314

Parameters:
  `k` - Liste der Konten.
Throws:
  `RemoteException`

### getURL

String getURL() throws RemoteException
Liefert die HTTPs-URL, ueber die die Bank erreichbar ist.

Returns:
  URL
Throws:
  `RemoteException`

### setURL

void setURL(String url) throws RemoteException
Speichert die HTTPs-URL, ueber die die Bank erreichbar ist. Wichtig: Das Protokoll ("https://") wird nicht mit abgespeichert.

Parameters:
  `url` - URL
Throws:
  `RemoteException`

### getPort

int getPort() throws RemoteException
Liefert den TCP-Port des Servers. Default: "443".

Returns:
  Port des Servers.
Throws:
  `RemoteException`

### setPort

void setPort(int port) throws RemoteException
Definiert den TCP-Port.

Parameters:
  `port` -
Throws:
  `RemoteException`

### getFilterType

String getFilterType() throws RemoteException
Liefert den Filter-Typ. Default: "Base64".

Returns:
  der Filter-Typ.
Throws:
  `RemoteException`

### setFilterType

void setFilterType(String type) throws RemoteException
Legt den Filter-Typ fest.

Parameters:
  `type` -
Throws:
  `RemoteException`

### getHBCIVersion

String getHBCIVersion() throws RemoteException
Liefert die HBCI-Version.

Returns:
  HBCI-Version.
Throws:
  `RemoteException`

### setHBCIVersion

void setHBCIVersion(String version) throws RemoteException
Speichert die zu verwendende HBCI-Version.

Parameters:
  `version` - HBCI-Version.
Throws:
  `RemoteException`

### getCustomerId

String getCustomerId() throws RemoteException
Liefert die Kundenkennung.

Returns:
  Kundenkennung.
Throws:
  `RemoteException`

### setCustomerId

void setCustomerId(String customer) throws RemoteException
Speichert die Kundenkennung.

Parameters:
  `customer` -
Throws:
  `RemoteException`

### getUserId

String getUserId() throws RemoteException
Liefert die Benutzerkennung.

Returns:
  Benutzerkennung.
Throws:
  `RemoteException`

### setUserId

void setUserId(String user) throws RemoteException
Speichert die Benutzerkennung.

Parameters:
  `user` -
Throws:
  `RemoteException`

### getFilename

String getFilename() throws RemoteException
Dateiname der HBCI4Java-Config.

Returns:
  HBCI4Java-Config.
Throws:
  `RemoteException`

### getPassport

org.kapott.hbci.passport.HBCIPassport getPassport() throws RemoteException
Liefert den Passport.

Returns:
  Passport.
Throws:
  `RemoteException`

### getBezeichnung

String getBezeichnung() throws RemoteException
Optionale Angabe einer Bezeichnung fuer die Konfig.

Returns:
  Bezeichnung.
Throws:
  `RemoteException`

### setBezeichnung

void setBezeichnung(String bezeichnung) throws RemoteException
Speichert eine optionale Bezeichnung fuer die Konfig.

Parameters:
  `bezeichnung` - Bezeichnung.
Throws:
  `RemoteException`

### getStoredSecMech

PtSecMech getStoredSecMech() throws RemoteException
Liefert das gespeicherte TAN-Verfahren.

Returns:
  das gespeicherte TAN-Verfahren oder NULL, wenn keines gespeichert wurde.
Throws:
  `RemoteException`

### setStoredSecMech

void setStoredSecMech(PtSecMech mech) throws RemoteException
Speichert das TAN-Verfahren permanent.

Parameters:
  `mech` - das TAN-Verfahrens.
Throws:
  `RemoteException`

### getCurrentSecMech

PtSecMech getCurrentSecMech() throws RemoteException
Liefert das aktuell ausgewaehlte TAN-Verfahren.

Returns:
  das aktuell ausgewaehlte TAN-Verfahren.
Throws:
  `RemoteException`

### setCurrentSecMech

void setCurrentSecMech(PtSecMech mech) throws RemoteException
Speichert das aktuell ausgewaehlte TAN-Verfahren.

Parameters:
  `mech` - das aktuell ausgewaehlte TAN-Verfahren.
Throws:
  `RemoteException`

### getAvailableSecMechs

List<PtSecMech> getAvailableSecMechs() throws RemoteException
Liefert die Liste der verfuegbaren TAN-Verfahren.

Returns:
  die Liste der verfuegbaren TAN-Verfahren. Nie NULL sondern hoechstens eine leere Liste.
Throws:
  `RemoteException`

### setAvailableSecMechs

void setAvailableSecMechs(String list) throws RemoteException
Speichert die Liste der verfuegbaren TAN-Verfahren.

Parameters:
  `list` - die Liste der verfuegbaren TAN-Verfahren als Pipe-separierte Liste.
Throws:
  `RemoteException`

### isChipTANUSB

Boolean isChipTANUSB() throws RemoteException
Liefert true, wenn chipTAN USB verwendet werden soll.

Returns:
  true, wenn chipTAN USB verwendet werden soll. false, wenn es nicht verwendet werden soll. NULL, wenn der User die Entscheidung noch nicht getroffen hat.
Throws:
  `RemoteException`

### setChipTANUSB

void setChipTANUSB(Boolean b) throws RemoteException
Legt fest, ob chipTAN USB genutzt werden soll.

Parameters:
  `b` - true, wenn chipTAN USB genutzt werden soll. false, wenn es nicht verwendet werden soll. NULL, wenn der User die Entscheidung noch nicht getroffen hat.
Throws:
  `RemoteException`

### isConvertFlickerToQRCode

boolean isConvertFlickerToQRCode() throws RemoteException
Liefert true, wenn statt einem Flicker-Code eine QR-Code-Abfrage erscheinen soll.

Returns:
  wenn QR-Code-Abfrage erzeugt werden soll. false, wenn weiterhin ein Flicker-Code erscheinen soll.
Throws:
  `RemoteException`

### setConvertFlickerToQRCode

void setConvertFlickerToQRCode(boolean b) throws RemoteException
Legt fest, ob statt einem Flicker-Code eine QR-Code-Abfrage erscheinen soll.

Parameters:
  `b` - true, wenn QR-Code-Abfrage erzeugt werden soll. false, wenn weiterhin ein Flicker-Code erscheinen soll.
Throws:
  `RemoteException`

### getCardReader

String getCardReader() throws RemoteException
Liefert eine optionale Bezeichnung fuer den zu nutzenden Karteleser.

Returns:
  eine optionale Bezeichnung fuer den zu nutzenden Karteleser.
Throws:
  `RemoteException`

### setCardReader

void setCardReader(String name) throws RemoteException
Speichert den Namen des zu verwendenden Kartenlesers.

Parameters:
  `name` - der Name des zu verwendenden Kartenlesers.
Throws:
  `RemoteException`

### getShowTan

boolean getShowTan() throws RemoteException
Prueft, ob die TAN waehrend der Eingabe angezeigt werden soll.

Returns:
  true, wenn die TANs angezeigt werden sollen.
Throws:
  `RemoteException`

### setShowTan

void setShowTan(boolean show) throws RemoteException
Legt fest, ob die TANs bei der Eingabe angezeigt werden sollen.

Parameters:
  `show` - true, wenn sie angezeigt werden sollen.
Throws:
  `RemoteException`

### getTanMedias

String[] getTanMedias() throws RemoteException
Liefert die Liste der zuletzt eingegebenen TAN-Medien-Bezeichnungen.

Returns:
  Liste der zuletzt eingegebenen TAN-Medien-Bezeichnungen.
Throws:
  `RemoteException`

### setTanMedias

void setTanMedias(String[] names) throws RemoteException
Speichert die Liste der zuletzt eingegebenen TAN-Medien-Bezeichnungen.

Parameters:
  `names` - die Liste der zuletzt eingegebenen TAN-Medien-Bezeichnungen.
Throws:
  `RemoteException`

### getAvailableTanMedias

List<String> getAvailableTanMedias() throws RemoteException
Liefert die Liste der von der Bank gelieferten TAN-Medien-Bezeichnungen.

Returns:
  Liste der von der Bank gelieferten TAN-Medien-Bezeichnungen. Nie NULL sondern hoechstens eine leere Liste.
Throws:
  `RemoteException`

### setAvailableTanMedias

void setAvailableTanMedias(String list) throws RemoteException
Speichert die Liste der von der Bank gelieferten TAN-Medien-Bezeichnungen.

Parameters:
  `list` - die Liste der von der Bank gelieferten TAN-Medien-Bezeichnungen als Pipe-separierte Liste.
Throws:
  `RemoteException`

### addTanMedia

void addTanMedia(String name) throws RemoteException
Fuegt ein neues TAN-Medium zur Liste der bekannten hinzu.

Parameters:
  `name` - die neue TAN-Medien-Bezeichnung.
Throws:
  `RemoteException`

### getTanMedia

String getTanMedia() throws RemoteException
Liefert das zuletzt verwendete TAN-Medium.

Returns:
  das zuletzt verwendete TAN-Medium.
Throws:
  `RemoteException`

### setTanMedia

void setTanMedia(String name) throws RemoteException
Speichert das zuletzt verwendete TAN-Medium.

Parameters:
  `name` - das zuletzt verwendete TAN-Medium.
Throws:
  `RemoteException`

### getCustomProperty

String getCustomProperty(String name) throws RemoteException
Liefert ein Custom-Property.

Parameters:
  `name` - Name des Property.
Returns:
  Wert des Property.
Throws:
  `RemoteException`

### setCustomProperty

void setCustomProperty(String name, String value) throws RemoteException
Speichert ein Custom-Property.

Parameters:
  `name` - Name des Property.
  `value` - Wert des Property.
Throws:
  `RemoteException`

### reload

void reload() throws RemoteException
Forciert ein Neuladen das in der Config gespeicherten Passport.

Throws:
  `RemoteException`